from functools import singledispatch
 
# základ generické funkce
@singledispatch
def funkce(arg1, arg2):
    print('Můj 1. argument:', arg1)
    print('Můj 2. argument:', arg2)
 
# dekorace podle typu v anotaci
@funkce.register
def _(arg1: int | float, arg2: str):
    print('1. argument je 1D-číslo:', arg1)
    print('2. argument je řetězec:', arg2)

@funkce.register
def _(arg1: int | float, arg2: int):
    print('1. argument je 1D-číslo:', arg1)
    print('2. argument je 1D-číslo:', arg2)
 
# dekorace podle explicitně uvedeného typu
@funkce.register
def _(arg1: complex, arg2: int):
    print('1. argument je 2D-číslo:', arg1.real, arg1.imag)
    print('2. argument je 1D-číslo:', arg2)
 
# testy
funkce(3, 6)
funkce(3.14, 6)
funkce(3 + 2j, 6)
funkce('Ahoj!', 666)

'''
1. argument je 1D-číslo: 3
2. argument je 1D-číslo: 6
1. argument je 1D-číslo: 3.14
2. argument je 1D-číslo: 6
1. argument je 2D-číslo: 3.0 2.0
2. argument je 1D-číslo: 6
Můj 1. argument: Ahoj!
Můj 2. argument: 666
'''
